# encoding: UTF-8

require 'json'
require 'htmlentities'

# The arrf file name and the json files must be given by command-line.
# For example ruby arff-document-data-generator.rb tweets-database.arff *.json

coder = HTMLEntities.new

File.open(ARGV.shift, 'a+') do |arff_file|  
	ARGV.each do |json_file|
		class_name = json_file.gsub(/[^\/]+\//, '')
		class_name = class_name.gsub(/.json/, '')
		puts class_name
		File.open(json_file, 'r') do |file| 
			while (line = file.gets)
				#	For each line it gathers the Twitter user name and its correspondent tweet text
				tweet = JSON.parse(line)
				tweet_decoded_text = coder.decode(tweet['text'])
				tweet_without_metadata = tweet_decoded_text.gsub(/(https?:\/\/[a-z0-9A-Z\/\.]*[a-z0-9A-Z]*\s?)|(#[^ ]*\s?)|(@[^ ]*\s?)|(RT\s?)|(\r+)|(\n+)/, ' ')
				tweet_text = tweet_without_metadata.gsub(/([\'\"])/, "\'" => "\\'", "\"" => '\"')
				tweet_text = tweet_text.gsub(/\s{2,}/, ' ')
				
        if tweet_text[0] = " "
				  tweet_text[0] = ''
				end
				if (tweet['from_user'] != nil)
					from_user = tweet['from_user']
				else
					from_user = tweet['user']['screen_name']
				end
				if (tweet_text.length > 35)
					arff_file.puts class_name + ",\'" + tweet_text + "\',\'" + from_user + "\'"
				end
			end 
		end
	end
end