#!/usr/bin/env ruby
require 'rubygems'
require 'gnuplot'
require 'iconv'
require 'csv'

#Refazer função
def gera_grafico questao_numero_respostas, nome_do_arquivo, pergunta 
  numero_de_questoes = 0
  x = []
  y = []
  # Gerando array de números dos eixos x e y.  Também faz-se a inserção de aspas nas strings
  # para que seus respectivos boxes sejam visualizados.
  questao_numero_respostas.each_value do |resposta|
    numero_de_questoes += resposta[1]
    y << resposta[1]
    x << resposta[0].dup
    x[-1].insert(0, '"')
    x[-1].insert(-1, '"')
  end

  #Produz porcentagem e pra exibir com o símbolo de '%' o vetor é transformado em string
  z = []
  questao_numero_respostas.each_value {|repostas_alternativa| z << ((repostas_alternativa[1].to_f/numero_de_questoes)*100).to_s[0..3] }
  z.each {|porcentagem| porcentagem.insert(-1, "%")}

  Gnuplot.open do |gp|
      Gnuplot::Plot.new( gp ) do |plot|
      
        plot.terminal 'png enhanced font ",11" size 800,600'
        plot.output "#{nome_do_arquivo}.png"
        plot.title pergunta
        plot.xtics "rotate by -10 scale 0"
        plot.yrange "[0:#{numero_de_questoes}]"
        plot.style "fill solid"
        plot.boxwidth "0.5"
        plot.bmargin "4"
        plot.lmargin "10"
        plot.rmargin  "10"

        plot.data << Gnuplot::DataSet.new( [x, y] ) do |ds|
          ds.with = "boxes"
          ds.using = "(column(0)):2:xtic(1)"
          ds.notitle
        end
        plot.data << Gnuplot::DataSet.new( [x, y, z] ) do |ds|
          ds.with = "labels"
          ds.using = "(column(0)):($2+1.5):3:xtic(1)"
          ds.notitle
        end
      end
  end
end


def gera_graficos dados_resp, seguranca_opcoes, questao_opcoes, tipo_analise
  if !File.directory? tipo_analise 
    `mkdir #{tipo_analise}`
  end
  i, j = 2, 1
  until i == dados_resp.length
    seguranca_opcoes[dados_resp[i][j].to_i][1] += 1
    i += 1
  end

  gera_grafico seguranca_opcoes, "#{dados_resp[0][j]}_#{tipo_analise}", dados_resp[1][j]
  seguranca_opcoes.each_value {|array| array[1] = 0}


  j = 2
  until j >= (dados_resp[0].length-2)
    i = 2
    until i == dados_resp.length
      questao_opcoes[dados_resp[i][j].to_i][1] += 1
      i += 1
    end
    gera_grafico questao_opcoes, "#{dados_resp[0][j]}_#{tipo_analise}", dados_resp[1][j]
    questao_opcoes.each_value {|array| array[1] = 0}

    j += 2
  end
  `mv *.png #{tipo_analise}`
end

def exclui_respostas_reprovadas_no_controle respostas, questoes_controle_hash, index
  conta_erradas = 0
  until index ==  respostas.length
    questoes_controle_hash.each_value do |value|
      if respostas[index][value[1]].to_i != value[0]
        respostas.delete_at(index)
        index -= 1
        conta_erradas += 1
        break
      end
    end
    index += 1
  end
end

def remove_sem_comentarios respostas, indice_inicial
  excluidos = 0
  if indice_inicial < 0
    index = indice_inicial + respostas.length
  else
    index = indice_inicial
  end

  until index >= respostas.length-2
    j = 3

    until j >= respostas[index].length-1
      if !respostas[index][j].nil?
        break
      end
      j += 2
    end

    if (j == respostas[index].length-1) and respostas[index][-2].nil?
      respostas.delete_at(index)
      index -= 1 
      excluidos += 1
    end
    index += 1
  end
  excluidos
end


file = File.new("relatorio-pesquisa.txt", "w")

*dados = CSV.read('Classificao_de_tweets.csv')
dados = dados.sort {|x, y| x[13].to_f <=> y[13].to_f}
dados.each {|linha| linha.shift(15)}

conhecimento_sobre_seguranca = {1 => ["Sim", 0], 2 => ["Não", 0]}

questoes = {1 => ["Alerta de segurança virtual", 0],
            2 => ["Não é alerta de segurança virtual", 0], 3 => ["Não sei", 0]}

questoes_controle = {"Q6" => [2], "Q8" => [1], "Q11" => [2], "Q13" => [2]}
dados[0].each_index do |index|
  if questoes_controle.has_key?(dados[0][index])
    questoes_controle[dados[0][index]] << index
  end
end

# Retirar dos dados as pessoas que não colocaram uma área válida e olhar todas as respostas de
# uma pessoa da coluna das questões para saber se todas as respostas são iguais. Nos casos em
# que isso ocorrer o respectivo conjuntod e respostas deve ser retirado
excluidos_por_respostas_iguais, excluidos_por_area_indesejada = 0, 0

i = 2 #Não quero pegar as duas primeiras linhas neste processamento
until i == dados.length
  dados[i][0] = Iconv.iconv('ascii//translit', 'utf-8', dados[i][0]).to_s.downcase

  if /bcc|computac|engenharia eletrica|informacao|software|telecomunicacoes/.match(dados[i][0]) == nil
    dados.delete_at(i)
    excluidos_por_area_indesejada += 1
    i -= 1
  else
    respostas_iguais = 1
    coluna = 4
    while (dados[i][2] == dados[i][coluna]) and (coluna < dados[i].length)
      coluna += 2
      respostas_iguais =+ 1
    end
    if respostas_iguais == 10
      dados.delete_at(i)
      excluidos_por_respostas_iguais += 1
      i -= 1
    end
  end
  i += 1
end

file.print "Foram excluídas #{excluidos_por_area_indesejada} pessoa(s) que não se encaixa(m) nas áreas de interesse pra pesquisa.\n"
file.print "Foram excluídas #{excluidos_por_respostas_iguais} pessoa(s) por terem dado a mesma resposta pra todas as questões.\n"

# ---------------------------------------------------------------------
#Olhando dados de todos os usuários aqui
dados_limpos = dados.dup
gera_graficos dados_limpos, conhecimento_sobre_seguranca, questoes, "histogramas_dados_limpos"

file.print "Os dados dos histogramas foram calculados sobre #{dados_limpos.length-2} participantes.\n"

# excluído do conjunto acima as linhas cujas respostas foram reprovadas pelo controle
exclui_respostas_reprovadas_no_controle dados_limpos, questoes_controle, 2
gera_graficos dados_limpos, conhecimento_sobre_seguranca, questoes, "histogramas_dados_limpos_controlados"

file.print "Após remover as linhas em que as respostas dadas foram reprovadas no controle sobraram #{dados_limpos.length-2} respostas.\n\n"

# ---------------------------------------------------------------------
# Dados de usuários sem os 5% mais rápidos e retirar entre os 5% mais lentos apenas os que não preencheram
# observações
conjunto_dados_reduzido = dados.dup
numero_usuarios_excluidos_a_esquerda = (5*100.to_f/(dados.length - 2)).ceil

questoes_array = conjunto_dados_reduzido[0..1]
conjunto_dados_reduzido.shift(numero_usuarios_excluidos_a_esquerda+2)
conjunto_dados_reduzido.insert(0, questoes_array[0], questoes_array[1])
ultimos_5_porcento = (5*100.to_f/(dados.length - 2)).ceil

numero_usuarios_excluidos_a_direita = remove_sem_comentarios conjunto_dados_reduzido, -1-ultimos_5_porcento

gera_graficos conjunto_dados_reduzido, conhecimento_sobre_seguranca, questoes, "histogramas_direita_esquerda"

file.print "Análise feita excluindo os #{numero_usuarios_excluidos_a_esquerda} preenchimentos mais rápidos (#{numero_usuarios_excluidos_a_esquerda*100.to_f/(dados.length - 2)}%) e
            #{numero_usuarios_excluidos_a_direita} (#{numero_usuarios_excluidos_a_direita*100.to_f/(dados.length - 2)}%) entre os 5% mais lentos.\n"
file.print "Agora há #{conjunto_dados_reduzido.length-2} respostas sendo analisadas\n"

# excluído do conjunto acima as linhas cujas respostas foram reprovadas pelo controle
exclui_respostas_reprovadas_no_controle conjunto_dados_reduzido, questoes_controle, 2
gera_graficos conjunto_dados_reduzido, conhecimento_sobre_seguranca, questoes, "histogramas_direita_esquerda_controlados"

file.print "Após remover as linhas em que as respostas dadas foram reprovadas no controle sobraram #{conjunto_dados_reduzido.length-2} respostas.\n\n"

# ---------------------------------------------------------------------
# Análise de dados de quem afirma ter noções de segurança
conjunto_manjadores_seguranca = dados.dup
index = 2
until index == conjunto_manjadores_seguranca.length 
  if conjunto_manjadores_seguranca[index][1].to_i != 1
    conjunto_manjadores_seguranca.delete_at(index)
    index -= 1
  end
  index += 1
end

gera_graficos conjunto_manjadores_seguranca, conhecimento_sobre_seguranca, questoes, "histogramas_conhecimento_sobre_seguranca"

file.print "Há #{conjunto_manjadores_seguranca.length-2} que dizem possuir conhecimentos sobre seguranca.\n"

# excluído do conjunto acima as linhas cujas respostas foram reprovadas pelo controle
exclui_respostas_reprovadas_no_controle conjunto_manjadores_seguranca, questoes_controle, 2
gera_graficos conjunto_manjadores_seguranca, conhecimento_sobre_seguranca, questoes, "histogramas_conhecimento_sobre_seguranca_controlados"

file.print "Após remover as linhas em que as respostas dadas foram reprovadas no controle sobraram #{conjunto_manjadores_seguranca.length-2} respostas.\n\n"

# ---------------------------------------------------------------------
# Análise dos dados de pessoas que escreveram comentários

conjunto_respostas_comentadas = dados.dup
removidos = remove_sem_comentarios conjunto_respostas_comentadas, 2

gera_graficos conjunto_respostas_comentadas, conhecimento_sobre_seguranca, questoes, "histogramas_respostas_comentadas"

file.print "Há #{conjunto_respostas_comentadas.length-2} que escreveram comentários seja em uma das questões ou nas observações.\n"

# excluído do conjunto acima as linhas cujas respostas foram reprovadas pelo controle
exclui_respostas_reprovadas_no_controle conjunto_respostas_comentadas, questoes_controle, 2
gera_graficos conjunto_respostas_comentadas, conhecimento_sobre_seguranca, questoes, "histogramas_respostas_comentadas_controlados"

file.print "Após remover as linhas em que as respostas dadas foram reprovadas no controle sobraram #{conjunto_respostas_comentadas.length-2} respostas.\n\n"

file.close
